package stackjava.com.accesslinkedin.common;

import java.io.IOException;

import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.fluent.Form;
import org.apache.http.client.fluent.Request;

import com.google.gson.Gson;
import com.google.gson.JsonObject;

public class LinkedInUtils {

	public static String getToken(final String code) throws ClientProtocolException, IOException {

		String response = Request.Post(Constants.LINKEDIN_LINK_GET_TOKEN)
				.bodyForm(Form.form().add("client_id", Constants.LINKEDIN_CLIENT_ID)
						.add("client_secret", Constants.LINKEDIN_CLIENT_SECRET)
						.add("redirect_uri", Constants.LINKEDIN_REDIRECT_URI).add("code", code)
						.add("grant_type", Constants.LINKEDIN_GRANT_TYPE).build())
				.execute().returnContent().asString();

		JsonObject jobj = new Gson().fromJson(response, JsonObject.class);
		String accessToken = jobj.get("access_token").toString().replaceAll("\"", "");
		return accessToken;
	}

	public static User getUserInfo(final String accessToken) throws ClientProtocolException, IOException {
		String link = Constants.LINKEDIN_LINK_GET_USER_INFO + accessToken;
		String response = Request.Get(link).execute().returnContent().asString();
		JsonObject jobj = new Gson().fromJson(response, JsonObject.class);
		String id = jobj.get("id").toString().replaceAll("\"", "");
		String firstName = jobj.get("firstName").toString().replaceAll("\"", "");
		String lastName = jobj.get("lastName").toString().replaceAll("\"", "");
		String name = firstName + lastName;
		User user = new User(id, name);
		return user;

	}

}
